
#
# Copyright (c) 1999-2003 LAAS/CNRS
# All rights reserved.
#
# Redistribution  and  use in source   and binary forms,  with or without
# modification, are permitted provided that  the following conditions are
# met:
#
#   1. Redistributions  of  source code must  retain  the above copyright
#      notice, this list of conditions and the following disclaimer.
#   2. Redistributions in binary form must  reproduce the above copyright
#      notice,  this list of  conditions and  the following disclaimer in
#      the  documentation   and/or  other  materials   provided with  the
#      distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE  AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY  EXPRESS OR IMPLIED WARRANTIES, INCLUDING,  BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES   OF MERCHANTABILITY AND  FITNESS  FOR  A PARTICULAR
# PURPOSE ARE DISCLAIMED.  IN NO  EVENT SHALL THE AUTHOR OR  CONTRIBUTORS
# BE LIABLE FOR ANY DIRECT, INDIRECT,  INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING,  BUT  NOT LIMITED TO, PROCUREMENT  OF
# SUBSTITUTE  GOODS OR SERVICES;  LOSS   OF  USE,  DATA, OR PROFITS;   OR
# BUSINESS  INTERRUPTION) HOWEVER CAUSED AND  ON ANY THEORY OF LIABILITY,
# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
# OTHERWISE) ARISING IN ANY WAY OUT OF THE  USE OF THIS SOFTWARE, EVEN IF
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

#
# This file was automagically generated.
# Manual editing not recommended. Changes will be overridden.
#

if { [lsearch [interp hidden] p3dInstall] >= 0 } {
    interp expose {} p3dInstall
}

proc ::p3dInstall { name } {
    foreach rqst { "Init" "GoToStop" "GoTo" "GetLamaGeom" "SetLamaGeom" "GetLamaLimits" "SetLamaLimits" "GetArcsParams" "SetArcsParams" "SetGoalParams" "GetGoalParams" "AddWayPoint" "ClearWayPoints" "ClearCurrentWayPoint" "Track" "TrackStop" "SetP3dPoster" "ReadDemP3dPoster" "SaveP3dMap" "PlaceRobotOnMap" "ConfigMonitor" "StopMonitor" "GetDumpParams" "SetDumpParams" "SpeedRefspeedRefPosterRead" "WayPointsgoalDistPosterRead" "WayPointswpListPosterRead" "PathpathPosterRead" "MonitoringmonitorDataPosterRead" "p3dStatusmovingStatusPosterRead"  } {
	interp alias {} ${name}::$rqst {} interp invoke {} p3d$rqst $name
    }
}

interp hide {} p3dInstall




# Init ----------------------------------------------------------

if { [lsearch [interp hidden] p3dInit] >= 0 } {
    interp expose {} p3dInit
}
if { [lsearch [interp hidden] p3dInitFormatOutput] >= 0 } {
    interp expose {} p3dInitFormatOutput
}

proc ::p3dInit { name args } {
    set format {}
    lappend format [list string "initParams.pomPoster" "" ]

    return [ ::cs::rqstSend "${name}" "Init" \
	"Initializes the P3D module" \
	"P3D_INIT\n| char pomPoster\[256\]\n" \
	1 \
	$format \
	$args ]
}


proc ::p3dInitFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} p3dInit
interp hide {} p3dInitFormatOutput





# GoToStop ----------------------------------------------------------

if { [lsearch [interp hidden] p3dGoToStop] >= 0 } {
    interp expose {} p3dGoToStop
}
if { [lsearch [interp hidden] p3dGoToStopFormatOutput] >= 0 } {
    interp expose {} p3dGoToStopFormatOutput
}

proc ::p3dGoToStop { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "GoToStop" \
	"stop the goto" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::p3dGoToStopFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} p3dGoToStop
interp hide {} p3dGoToStopFormatOutput





# GoTo ----------------------------------------------------------

if { [lsearch [interp hidden] p3dGoTo] >= 0 } {
    interp expose {} p3dGoTo
}
if { [lsearch [interp hidden] p3dGoToFormatOutput] >= 0 } {
    interp expose {} p3dGoToFormatOutput
}

proc ::p3dGoTo { name args } {
    set format {}
    lappend format [list float "X coordinate" 0.000000 ]
    lappend format [list float "Y coordinate" 0.000000 ]
    lappend format [list { "GENPOS_BACKWARD_MOTION" "GENPOS_FORWARD_MOTION" } "Motion direction" "GENPOS_FORWARD_MOTION" ]

    return [ ::cs::rqstSend "${name}" "GoTo" \
	"a nice goto that ends" \
	"P3DWayPoint\n| float x\n| float y\n| GENPOS_MOTION_DIRECTION dir\n" \
	3 \
	$format \
	$args ]
}


proc ::p3dGoToFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} p3dGoTo
interp hide {} p3dGoToFormatOutput





# GetLamaGeom ----------------------------------------------------------

if { [lsearch [interp hidden] p3dGetLamaGeom] >= 0 } {
    interp expose {} p3dGetLamaGeom
}
if { [lsearch [interp hidden] p3dGetLamaGeomFormatOutput] >= 0 } {
    interp expose {} p3dGetLamaGeomFormatOutput
}

proc ::p3dGetLamaGeom { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "GetLamaGeom" \
	"Show (lama) wheel geometry" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::p3dGetLamaGeomFormatOutput { list } {
    set format { {} status { } { geomP { } len0 { } len1 { } len2 { } rad0 { } rad1 { } arm0 { } arm1 { } scale { } rollStep { } vMin { } vMax { } accel { } decel { } wMax { } bodyLength { } bodyWidth { } zBody { } groundClear } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} p3dGetLamaGeom
interp hide {} p3dGetLamaGeomFormatOutput





# SetLamaGeom ----------------------------------------------------------

if { [lsearch [interp hidden] p3dSetLamaGeom] >= 0 } {
    interp expose {} p3dSetLamaGeom
}
if { [lsearch [interp hidden] p3dSetLamaGeomFormatOutput] >= 0 } {
    interp expose {} p3dSetLamaGeomFormatOutput
}

proc ::p3dSetLamaGeom { name args } {
    set format {}
    lappend format [list float "Big cylinder length" 0.168000 ]
    lappend format [list float "Cone length" 0.337000 ]
    lappend format [list float "Axle length" 0.000000 ]
    lappend format [list float "Big cylinder radius" 0.530000 ]
    lappend format [list float "Axle radius" 0.090000 ]
    lappend format [list float "Front arm length" 0.285000 ]
    lappend format [list float "Back arm length" 0.285000 ]
    lappend format [list float "Bitmap scale (m/pixel)" 0.040000 ]
    lappend format [list double "Roll precision (deg)" 1.000000 ]
    lappend format [list double "Min linear speed" 0.030000 ]
    lappend format [list double "Max linear speed" 0.100000 ]
    lappend format [list double "Max linear acceleration (ms-2)" 1 ]
    lappend format [list double "Max linear deceleration (ms-2)" 1 ]
    lappend format [list double "Max angular speed" 0.030000 ]
    lappend format [list double "ATRV's Body Length (bas de caisse)" 0.950000 ]
    lappend format [list double "ATRV's Body With (bas de caisse)" 0.390000 ]
    lappend format [list double "ATRV's z(center to body) (bas de caisse)" -0.415000 ]
    lappend format [list double "ground clearance (garde au sol)" 0.115000 ]

    return [ ::cs::rqstSend "${name}" "SetLamaGeom" \
	"Change (lama) wheel geometry" \
	"P3DLamaGeom\n| float len0\n| float len1\n| float len2\n| float rad0\n| float rad1\n| float arm0\n| float arm1\n| float scale\n| double rollStep\n| double vMin\n| double vMax\n| double accel\n| double decel\n| double wMax\n| double bodyLength\n| double bodyWidth\n| double zBody\n| double groundClear\n" \
	18 \
	$format \
	$args ]
}


proc ::p3dSetLamaGeomFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} p3dSetLamaGeom
interp hide {} p3dSetLamaGeomFormatOutput





# GetLamaLimits ----------------------------------------------------------

if { [lsearch [interp hidden] p3dGetLamaLimits] >= 0 } {
    interp expose {} p3dGetLamaLimits
}
if { [lsearch [interp hidden] p3dGetLamaLimitsFormatOutput] >= 0 } {
    interp expose {} p3dGetLamaLimitsFormatOutput
}

proc ::p3dGetLamaLimits { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "GetLamaLimits" \
	"Show lama limits" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::p3dGetLamaLimitsFormatOutput { list } {
    set format { {} status { } { limitsP { 3 } rollLimits { 3 } pitchLimits { 3 } alphaLimits { 3 } betaLimits { } unkMax } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} p3dGetLamaLimits
interp hide {} p3dGetLamaLimitsFormatOutput





# SetLamaLimits ----------------------------------------------------------

if { [lsearch [interp hidden] p3dSetLamaLimits] >= 0 } {
    interp expose {} p3dSetLamaLimits
}
if { [lsearch [interp hidden] p3dSetLamaLimitsFormatOutput] >= 0 } {
    interp expose {} p3dSetLamaLimitsFormatOutput
}

proc ::p3dSetLamaLimits { name args } {
    set format {}
    for {set loop1(0) 0} { $loop1(0)<3 } { incr loop1(0)} {
    lappend format [list double "Max roll of middle axle for easy configuration (deg)" 12.500000 ]
}
    for {set loop1(0) 0} { $loop1(0)<3 } { incr loop1(0)} {
    lappend format [list double "Max roll of middle axle for medium configuration (deg)" 25.000000 ]
}
    for {set loop1(0) 0} { $loop1(0)<3 } { incr loop1(0)} {
    lappend format [list double "Max roll of middle axle for hard configuration (deg)" 35.000000 ]
}
    for {set loop1(0) 0} { $loop1(0)<3 } { incr loop1(0)} {
    lappend format [list double "Max pitch of middle axle for easy configuration (deg)" 12.500000 ]
}
    lappend format [list double "Max pitch of middle axle for medium configuration (deg)" 25.000000 ]

    return [ ::cs::rqstSend "${name}" "SetLamaLimits" \
	"Change lama limits" \
	"P3DLamaLimits\n| double rollLimits\[3\]\n| double pitchLimits\[3\]\n| double alphaLimits\[3\]\n| double betaLimits\[3\]\n| double unkMax\n" \
	13 \
	$format \
	$args ]
}


proc ::p3dSetLamaLimitsFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} p3dSetLamaLimits
interp hide {} p3dSetLamaLimitsFormatOutput





# GetArcsParams ----------------------------------------------------------

if { [lsearch [interp hidden] p3dGetArcsParams] >= 0 } {
    interp expose {} p3dGetArcsParams
}
if { [lsearch [interp hidden] p3dGetArcsParamsFormatOutput] >= 0 } {
    interp expose {} p3dGetArcsParamsFormatOutput
}

proc ::p3dGetArcsParams { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "GetArcsParams" \
	"Show arcs parameters" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::p3dGetArcsParamsFormatOutput { list } {
    set format { {} status { } { arcsP { } nArcs { } nNodes { } depth { } rMin { } dMin { } goalToal { } p3d_dMin } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} p3dGetArcsParams
interp hide {} p3dGetArcsParamsFormatOutput





# SetArcsParams ----------------------------------------------------------

if { [lsearch [interp hidden] p3dSetArcsParams] >= 0 } {
    interp expose {} p3dSetArcsParams
}
if { [lsearch [interp hidden] p3dSetArcsParamsFormatOutput] >= 0 } {
    interp expose {} p3dSetArcsParamsFormatOutput
}

proc ::p3dSetArcsParams { name args } {
    set format {}
    lappend format [list int "Number of arcs (total)" 20 ]
    lappend format [list int "Number of nodes (by arcs)" 10 ]
    lappend format [list int "Nesting depth" 2 ]
    lappend format [list float "Min radius" 1.000000 ]
    lappend format [list float "Min arc length" 0.500000 ]
    lappend format [list float "Goal tolerance (m)" 0.500000 ]
    lappend format [list float "length of arc in p3d algo (m)" 2.000000 ]

    return [ ::cs::rqstSend "${name}" "SetArcsParams" \
	"Change arcs parameters" \
	"P3DArcsParams\n| int nArcs\n| int nNodes\n| int depth\n| float rMin\n| float dMin\n| float goalToal\n| float p3d_dMin\n" \
	7 \
	$format \
	$args ]
}


proc ::p3dSetArcsParamsFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} p3dSetArcsParams
interp hide {} p3dSetArcsParamsFormatOutput





# SetGoalParams ----------------------------------------------------------

if { [lsearch [interp hidden] p3dSetGoalParams] >= 0 } {
    interp expose {} p3dSetGoalParams
}
if { [lsearch [interp hidden] p3dSetGoalParamsFormatOutput] >= 0 } {
    interp expose {} p3dSetGoalParamsFormatOutput
}

proc ::p3dSetGoalParams { name args } {
    set format {}
    lappend format [list double "Percentage of traj before new plan" 0.100000 ]
    lappend format [list double "Angle limit at which we start U-turn" 100 ]
    lappend format [list double "Angle at which we stop the current U-turn" 30 ]

    return [ ::cs::rqstSend "${name}" "SetGoalParams" \
	"** undocumented **" \
	"P3DPlanParams\n| double period\n| double thetaUTurnHi\n| double thetaUTurnLow\n" \
	3 \
	$format \
	$args ]
}


proc ::p3dSetGoalParamsFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} p3dSetGoalParams
interp hide {} p3dSetGoalParamsFormatOutput





# GetGoalParams ----------------------------------------------------------

if { [lsearch [interp hidden] p3dGetGoalParams] >= 0 } {
    interp expose {} p3dGetGoalParams
}
if { [lsearch [interp hidden] p3dGetGoalParamsFormatOutput] >= 0 } {
    interp expose {} p3dGetGoalParamsFormatOutput
}

proc ::p3dGetGoalParams { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "GetGoalParams" \
	"Show Goal Params" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::p3dGetGoalParamsFormatOutput { list } {
    set format { {} status { } { planP { } period { } thetaUTurnHi { } thetaUTurnLow } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} p3dGetGoalParams
interp hide {} p3dGetGoalParamsFormatOutput





# AddWayPoint ----------------------------------------------------------

if { [lsearch [interp hidden] p3dAddWayPoint] >= 0 } {
    interp expose {} p3dAddWayPoint
}
if { [lsearch [interp hidden] p3dAddWayPointFormatOutput] >= 0 } {
    interp expose {} p3dAddWayPointFormatOutput
}

proc ::p3dAddWayPoint { name args } {
    set format {}
    lappend format [list float "X coordinate" 0.000000 ]
    lappend format [list float "Y coordinate" 0.000000 ]
    lappend format [list { "GENPOS_BACKWARD_MOTION" "GENPOS_FORWARD_MOTION" } "Motion direction" "GENPOS_FORWARD_MOTION" ]

    return [ ::cs::rqstSend "${name}" "AddWayPoint" \
	"Add a new goal" \
	"P3DWayPoint\n| float x\n| float y\n| GENPOS_MOTION_DIRECTION dir\n" \
	3 \
	$format \
	$args ]
}


proc ::p3dAddWayPointFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} p3dAddWayPoint
interp hide {} p3dAddWayPointFormatOutput





# ClearWayPoints ----------------------------------------------------------

if { [lsearch [interp hidden] p3dClearWayPoints] >= 0 } {
    interp expose {} p3dClearWayPoints
}
if { [lsearch [interp hidden] p3dClearWayPointsFormatOutput] >= 0 } {
    interp expose {} p3dClearWayPointsFormatOutput
}

proc ::p3dClearWayPoints { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "ClearWayPoints" \
	"** undocumented **" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::p3dClearWayPointsFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} p3dClearWayPoints
interp hide {} p3dClearWayPointsFormatOutput





# ClearCurrentWayPoint ----------------------------------------------------------

if { [lsearch [interp hidden] p3dClearCurrentWayPoint] >= 0 } {
    interp expose {} p3dClearCurrentWayPoint
}
if { [lsearch [interp hidden] p3dClearCurrentWayPointFormatOutput] >= 0 } {
    interp expose {} p3dClearCurrentWayPointFormatOutput
}

proc ::p3dClearCurrentWayPoint { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "ClearCurrentWayPoint" \
	"** undocumented **" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::p3dClearCurrentWayPointFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} p3dClearCurrentWayPoint
interp hide {} p3dClearCurrentWayPointFormatOutput





# Track ----------------------------------------------------------

if { [lsearch [interp hidden] p3dTrack] >= 0 } {
    interp expose {} p3dTrack
}
if { [lsearch [interp hidden] p3dTrackFormatOutput] >= 0 } {
    interp expose {} p3dTrackFormatOutput
}

proc ::p3dTrack { name args } {
    set format {}
    lappend format [list string "poster name" "" ]

    return [ ::cs::rqstSend "${name}" "Track" \
	"Track a GENPOS_CART_CONFIG poster, as produced from Nav for instance" \
	"P3DSDIIo\n| char fileName\[1024\]\n" \
	1 \
	$format \
	$args ]
}


proc ::p3dTrackFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} p3dTrack
interp hide {} p3dTrackFormatOutput





# TrackStop ----------------------------------------------------------

if { [lsearch [interp hidden] p3dTrackStop] >= 0 } {
    interp expose {} p3dTrackStop
}
if { [lsearch [interp hidden] p3dTrackStopFormatOutput] >= 0 } {
    interp expose {} p3dTrackStopFormatOutput
}

proc ::p3dTrackStop { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "TrackStop" \
	"Stop tracking" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::p3dTrackStopFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} p3dTrackStop
interp hide {} p3dTrackStopFormatOutput





# SetP3dPoster ----------------------------------------------------------

if { [lsearch [interp hidden] p3dSetP3dPoster] >= 0 } {
    interp expose {} p3dSetP3dPoster
}
if { [lsearch [interp hidden] p3dSetP3dPosterFormatOutput] >= 0 } {
    interp expose {} p3dSetP3dPosterFormatOutput
}

proc ::p3dSetP3dPoster { name args } {
    set format {}
    lappend format [list string "Name of dem Poster" "dtmP3dPoster" ]

    return [ ::cs::rqstSend "${name}" "SetP3dPoster" \
	"Set P3d Poster containing the map" \
	"GEN_STRING64\n| char name\[64\]\n" \
	1 \
	$format \
	$args ]
}


proc ::p3dSetP3dPosterFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} p3dSetP3dPoster
interp hide {} p3dSetP3dPosterFormatOutput





# ReadDemP3dPoster ----------------------------------------------------------

if { [lsearch [interp hidden] p3dReadDemP3dPoster] >= 0 } {
    interp expose {} p3dReadDemP3dPoster
}
if { [lsearch [interp hidden] p3dReadDemP3dPosterFormatOutput] >= 0 } {
    interp expose {} p3dReadDemP3dPosterFormatOutput
}

proc ::p3dReadDemP3dPoster { name args } {
    set format {}
    lappend format [list string "Name of dem Poster" "dtmP3dPoster" ]

    return [ ::cs::rqstSend "${name}" "ReadDemP3dPoster" \
	"Read dem Poster containing the map" \
	"GEN_STRING64\n| char name\[64\]\n" \
	1 \
	$format \
	$args ]
}


proc ::p3dReadDemP3dPosterFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} p3dReadDemP3dPoster
interp hide {} p3dReadDemP3dPosterFormatOutput





# SaveP3dMap ----------------------------------------------------------

if { [lsearch [interp hidden] p3dSaveP3dMap] >= 0 } {
    interp expose {} p3dSaveP3dMap
}
if { [lsearch [interp hidden] p3dSaveP3dMapFormatOutput] >= 0 } {
    interp expose {} p3dSaveP3dMapFormatOutput
}

proc ::p3dSaveP3dMap { name args } {
    set format {}
    lappend format [list string "File Name" "/home/tpeynot/Images/p3dmap" ]

    return [ ::cs::rqstSend "${name}" "SaveP3dMap" \
	"Save current P3d Map in file" \
	"P3D_SAVEMAP_PARAMS\n| char fileName\[1024\]\n" \
	1 \
	$format \
	$args ]
}


proc ::p3dSaveP3dMapFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} p3dSaveP3dMap
interp hide {} p3dSaveP3dMapFormatOutput





# PlaceRobotOnMap ----------------------------------------------------------

if { [lsearch [interp hidden] p3dPlaceRobotOnMap] >= 0 } {
    interp expose {} p3dPlaceRobotOnMap
}
if { [lsearch [interp hidden] p3dPlaceRobotOnMapFormatOutput] >= 0 } {
    interp expose {} p3dPlaceRobotOnMapFormatOutput
}

proc ::p3dPlaceRobotOnMap { name args } {
    set format {}
    lappend format [list double "x" 2.000000 ]
    lappend format [list double "y" 0.000000 ]
    lappend format [list double "theta" 0.000000 ]
    lappend format [list int "GDHE Display ? (0/1)" 0 ]
    lappend format [list int "unused" 0 ]

    return [ ::cs::rqstSend "${name}" "PlaceRobotOnMap" \
	"Try to place the Robot on Map" \
	"P3D_PLACEROBOT_PARAMS\n| double x\n| double y\n| double theta\n| int gdheDisplay\n| int unused\n" \
	5 \
	$format \
	$args ]
}


proc ::p3dPlaceRobotOnMapFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} p3dPlaceRobotOnMap
interp hide {} p3dPlaceRobotOnMapFormatOutput





# ConfigMonitor ----------------------------------------------------------

if { [lsearch [interp hidden] p3dConfigMonitor] >= 0 } {
    interp expose {} p3dConfigMonitor
}
if { [lsearch [interp hidden] p3dConfigMonitorFormatOutput] >= 0 } {
    interp expose {} p3dConfigMonitorFormatOutput
}

proc ::p3dConfigMonitor { name args } {
    set format {}
    lappend format [list { "P3D_MONITOR_LOG_ON" "P3D_MONITOR_LOG_OFF" } "Activate Logging on file ?" "P3D_MONITOR_LOG_OFF" ]
    lappend format [list int "unused" 0 ]
    lappend format [list string "Log File Name" "/home/tpeynot/Images/p3dMonitorLog.data" ]

    return [ ::cs::rqstSend "${name}" "ConfigMonitor" \
	"Compares predicted/observed configuration on-line" \
	"P3D_MONITOR_PARAMS\n| P3D_MONITOR_LOG_FLAG logFlag\n| int unused\n| char fileName\[1024\]\n" \
	3 \
	$format \
	$args ]
}


proc ::p3dConfigMonitorFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} p3dConfigMonitor
interp hide {} p3dConfigMonitorFormatOutput





# StopMonitor ----------------------------------------------------------

if { [lsearch [interp hidden] p3dStopMonitor] >= 0 } {
    interp expose {} p3dStopMonitor
}
if { [lsearch [interp hidden] p3dStopMonitorFormatOutput] >= 0 } {
    interp expose {} p3dStopMonitorFormatOutput
}

proc ::p3dStopMonitor { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "StopMonitor" \
	"Just to stop ConfigMonitor" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::p3dStopMonitorFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} p3dStopMonitor
interp hide {} p3dStopMonitorFormatOutput





# GetDumpParams ----------------------------------------------------------

if { [lsearch [interp hidden] p3dGetDumpParams] >= 0 } {
    interp expose {} p3dGetDumpParams
}
if { [lsearch [interp hidden] p3dGetDumpParamsFormatOutput] >= 0 } {
    interp expose {} p3dGetDumpParamsFormatOutput
}

proc ::p3dGetDumpParams { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "GetDumpParams" \
	"Print the Dump arc Params" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::p3dGetDumpParamsFormatOutput { list } {
    set format { {} status { } { dumpParams { } baseName { } num { } status } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} p3dGetDumpParams
interp hide {} p3dGetDumpParamsFormatOutput





# SetDumpParams ----------------------------------------------------------

if { [lsearch [interp hidden] p3dSetDumpParams] >= 0 } {
    interp expose {} p3dSetDumpParams
}
if { [lsearch [interp hidden] p3dSetDumpParamsFormatOutput] >= 0 } {
    interp expose {} p3dSetDumpParamsFormatOutput
}

proc ::p3dSetDumpParams { name args } {
    set format {}
    lappend format [list string "basename" "/tmp" ]
    lappend format [list int "number" 0 ]
    lappend format [list { "P3D_DUMP_ON" "P3D_DUMP_OFF" } "Dump activation" "P3D_DUMP_OFF" ]

    return [ ::cs::rqstSend "${name}" "SetDumpParams" \
	"Set Dump arcs Params" \
	"P3D_DUMP_PARAMS\n| char baseName\[256\]\n| int num\n| P3D_DUMP_STATUS status\n" \
	3 \
	$format \
	$args ]
}


proc ::p3dSetDumpParamsFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} p3dSetDumpParams
interp hide {} p3dSetDumpParamsFormatOutput





# SpeedRefspeedRef ----------------------------------------------------------

if { [lsearch [interp hidden] p3dSpeedRefspeedRefPosterRead] >= 0 } {
    interp expose {} p3dSpeedRefspeedRefPosterRead
}
if { [lsearch [interp hidden] p3dSpeedRefspeedRefPosterFormatOutput] >= 0 } {
    interp expose {} p3dSpeedRefspeedRefPosterFormatOutput
}

proc ::p3dSpeedRefspeedRefPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "SpeedRefspeedRef" \
	"GENPOS_CART_SPEED\n| int numRef\n| int updatePeriod\n| double v\n| double vt\n| double w\n| double vmax\n| double wmax\n| double linAccelMax\n| double angAccelMax\n" \
	$args ]
}


proc ::p3dSpeedRefspeedRefPosterFormatOutput { list } {
    set format { {} status { } { speedRef { } numRef { } updatePeriod { } v { } vt { } w { } vmax { } wmax { } linAccelMax { } angAccelMax } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} p3dSpeedRefspeedRefPosterRead
interp hide {} p3dSpeedRefspeedRefPosterFormatOutput





# WayPointsgoalDist ----------------------------------------------------------

if { [lsearch [interp hidden] p3dWayPointsgoalDistPosterRead] >= 0 } {
    interp expose {} p3dWayPointsgoalDistPosterRead
}
if { [lsearch [interp hidden] p3dWayPointsgoalDistPosterFormatOutput] >= 0 } {
    interp expose {} p3dWayPointsgoalDistPosterFormatOutput
}

proc ::p3dWayPointsgoalDistPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "WayPointsgoalDist" \
	"P3DGoalDistance\n| double distance\n" \
	$args ]
}


proc ::p3dWayPointsgoalDistPosterFormatOutput { list } {
    set format { {} status { } { goalDist { } distance } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} p3dWayPointsgoalDistPosterRead
interp hide {} p3dWayPointsgoalDistPosterFormatOutput





# WayPointswpList ----------------------------------------------------------

if { [lsearch [interp hidden] p3dWayPointswpListPosterRead] >= 0 } {
    interp expose {} p3dWayPointswpListPosterRead
}
if { [lsearch [interp hidden] p3dWayPointswpListPosterFormatOutput] >= 0 } {
    interp expose {} p3dWayPointswpListPosterFormatOutput
}

proc ::p3dWayPointswpListPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "WayPointswpList" \
	"P3DWayPointList\n| int number\n| P3DWayPoint\n| | float x\n| | float y\n| | GENPOS_MOTION_DIRECTION dir\n" \
	$args ]
}


proc ::p3dWayPointswpListPosterFormatOutput { list } {
    set format { {} status { } { wpList { } number { 1000 } { wps { } x { } y { } dir } } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} p3dWayPointswpListPosterRead
interp hide {} p3dWayPointswpListPosterFormatOutput





# Pathpath ----------------------------------------------------------

if { [lsearch [interp hidden] p3dPathpathPosterRead] >= 0 } {
    interp expose {} p3dPathpathPosterRead
}
if { [lsearch [interp hidden] p3dPathpathPosterFormatOutput] >= 0 } {
    interp expose {} p3dPathpathPosterFormatOutput
}

proc ::p3dPathpathPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "Pathpath" \
	"P3DSolution\n| int depth\n| double ds\n| P3DArcGen\n| | double r\n| | double cost\n| | int n\n| | int current\n| | P3DNodeGen\n| | | double x\n| | | double y\n| | | double theta\n| | | P3DRobotConfigGen\n| | | | double q\n| | | | double x\n| | | | double y\n| | | | double z\n| | | | double theta\n| | | | double dzBodyGround\n| | | | double roll\n| | | | double pitch\n| | | | double alpha1\n| | | | double alpha2\n| | | | double beta3\n| | | | double pUnk\n| | | double cost\n| | | double remain\n| | | int number\n| | | int isLocalMin\n" \
	$args ]
}


proc ::p3dPathpathPosterFormatOutput { list } {
    set format { {} status { } { path { } depth { } ds { 10 } { arcs { } r { } cost { } n { } current { 20 } { nodes { } x { } y { } theta { } { conf { } q { } x { } y { } z { } theta { } dzBodyGround { } roll { } pitch { } alpha1 { } alpha2 { } beta3 { } pUnk } { } cost { } remain { } number { } isLocalMin } } } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} p3dPathpathPosterRead
interp hide {} p3dPathpathPosterFormatOutput





# MonitoringmonitorData ----------------------------------------------------------

if { [lsearch [interp hidden] p3dMonitoringmonitorDataPosterRead] >= 0 } {
    interp expose {} p3dMonitoringmonitorDataPosterRead
}
if { [lsearch [interp hidden] p3dMonitoringmonitorDataPosterFormatOutput] >= 0 } {
    interp expose {} p3dMonitoringmonitorDataPosterFormatOutput
}

proc ::p3dMonitoringmonitorDataPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "MonitoringmonitorData" \
	"P3D_MONITOR_DATA\n| double distPitch\n| double distRoll\n| double probaPitch\n| double probaRoll\n| double behavior\n| P3D_MONITOR_STATUS status\n| int unused\n" \
	$args ]
}


proc ::p3dMonitoringmonitorDataPosterFormatOutput { list } {
    set format { {} status { } { monitorData { } distPitch { } distRoll { } probaPitch { } probaRoll { } behavior { } status { } unused } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} p3dMonitoringmonitorDataPosterRead
interp hide {} p3dMonitoringmonitorDataPosterFormatOutput





# p3dStatusmovingStatus ----------------------------------------------------------

if { [lsearch [interp hidden] p3dp3dStatusmovingStatusPosterRead] >= 0 } {
    interp expose {} p3dp3dStatusmovingStatusPosterRead
}
if { [lsearch [interp hidden] p3dp3dStatusmovingStatusPosterFormatOutput] >= 0 } {
    interp expose {} p3dp3dStatusmovingStatusPosterFormatOutput
}

proc ::p3dp3dStatusmovingStatusPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "p3dStatusmovingStatus" \
	"P3DStatus\n| P3D_STATUS_FLAG status\n| int blocked_cycles\n" \
	$args ]
}


proc ::p3dp3dStatusmovingStatusPosterFormatOutput { list } {
    set format { {} status { } { movingStatus { } status { } blocked_cycles } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} p3dp3dStatusmovingStatusPosterRead
interp hide {} p3dp3dStatusmovingStatusPosterFormatOutput


